-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local max = math.max
--local min = math.min
--local clamp = clamp
--local abs = math.abs
local floor = math.floor
local psToWatt = 735.499
--local sign = sign
local huge = math.huge
--local deltaT= 0
local clutchMaxTorque= 100  --修改离合扭矩用，但不是必须
local storedJbeamData
local combustionEngineList={}

local function scaleEngineTorqueInertiaDurability1()
    for _,a in pairs(powertrain.getDevices()) do    --修改发动机和电机扭矩
        if a.type=="electricMotor" or a.type=="electricMotorModded" or a.type=="combustionEngine" then
            a.torqueData.maxTorque= a.torqueData.maxTorque* (storedJbeamData.engineTorqueAdjust or 1)
            a.torqueData.maxPower= a.torqueData.maxPower* (storedJbeamData.engineTorqueAdjust or 1)
            a.maxTorque= a.torqueData.maxTorque
            a.maxPower= a.torqueData.maxPower
            a.maxPowerThrottleMap = a.torqueData.maxPower * psToWatt
            local torqueCurveScale= a.torqueCurve
            --log('I', "",  dumps(a.torqueData.maxTorque))
            clutchMaxTorque= max(clutchMaxTorque, a.torqueData.maxTorque)
            for k, v in pairs(torqueCurveScale) do
                torqueCurveScale[k] = torqueCurveScale[k]* (storedJbeamData.engineTorqueAdjust or 1)
                clutchMaxTorque= max(clutchMaxTorque, torqueCurveScale[k])
                
            end
            --log('I', "",  dumps(a.name))
            --log('I', "",  "   halfInvEngInertia"..dumps(a.halfInvEngInertia))
            a.torqueCurve= torqueCurveScale

            if not(a.name=="frontMotor" or a.name=="rearMotor" or a.name=="frontRightMotor" or a.name=="rearRightMotor") then
                a.inertia = max(0.1, a.inertia* (storedJbeamData.engineTorqueAdjust or 1)* (storedJbeamData.engineInertiaAdjust or 1))
                a.invEngInertia = 1/ a.inertia
                a.halfInvEngInertia = a.invEngInertia/ 2
            end
            --log('I', "",  dumps(a.inertia))
        end


        if a.type == "combustionEngine" then --修改发动机耐久
            table.insert(combustionEngineList,a.name)

            a.cylinderWallTemperatureDamageThreshold = huge
            a.headGasketDamageThreshold = huge
            a.pistonRingDamageThreshold = huge
            a.connectingRodDamageThreshold = huge
            a.maxOverTorqueDamage = huge
            a.maxOverRevDamage = huge
            a.maxTorqueRating = -1
            --powertrain.getDevice(_).jbeamData.thermalsLuaFileName = "powertrain/combustionEngineThermalsModded"
            --powertrain.getDevice(_).thermals = require("powertrain/combustionEngineThermalsModded")
            --log('I', "",  dumps(jbeamData))
            a.idleTorque = a.torqueCurve[floor(a.idleRPM)] or 10
            a.engineBrakeTorque= a.inertia* a.maxRPM* 0.03

            a.starterTorque= a.inertia* 1000
            --powertrain.getDevice(_).torqueCurve = createCurve(torqueCurveScale)
            --log('I', "",  dumps(powertrain.getDevice(_).idleTorque))
            --log('I', "", "device name:".. dumps(_))
            --log('I', "", "  ".. dumps(a))
        end

    end
end

local function scaleEngineTorqueInertia1(engineData,gearRatio)
    local a= powertrain.getDevice(engineData.name)
    if a.type=="electricMotor" or a.type=="electricMotorModded" or a.type=="combustionEngine" and gearRatio~=0 then
        a.torqueData.maxTorque= engineData.torqueData.maxTorque* ((storedJbeamData.engineTorqueAdjust/gearRatio) or 1)
        a.torqueData.maxPower= engineData.torqueData.maxPower* ((storedJbeamData.engineTorqueAdjust/gearRatio) or 1)
        a.maxTorque= a.torqueData.maxTorque
        a.maxPower= a.torqueData.maxPower
        a.maxPowerThrottleMap = a.torqueData.maxPower * psToWatt
        local torqueCurveScale= engineData.torqueCurve
        --log('I', "",  dumps(a.torqueData.maxTorque))
        clutchMaxTorque=  a.torqueData.maxTorque
        for k, v in pairs(torqueCurveScale) do
            torqueCurveScale[k] = torqueCurveScale[k]* ((storedJbeamData.engineTorqueAdjust/gearRatio) or 1)
            clutchMaxTorque= max(clutchMaxTorque, torqueCurveScale[k])
            
        end
        --log('I', "",  dumps(a.name))
        --log('I', "",  "   "..dumps(a.children.name))
        a.torqueCurve= torqueCurveScale

        if not(a.name=="frontMotor" or a.name=="rearMotor" or a.name=="frontRightMotor" or a.name=="rearRightMotor") then
            a.inertia = engineData.inertia* ((storedJbeamData.engineTorqueAdjust/gearRatio) or 1)* (storedJbeamData.engineInertiaAdjust or 1)
            a.invEngInertia = engineData.invEngInertia/ ((storedJbeamData.engineTorqueAdjust* gearRatio) or 1)/ (storedJbeamData.engineInertiaAdjust or 1)
            a.halfInvEngInertia = engineData.halfInvEngInertia/ ((storedJbeamData.engineTorqueAdjust* gearRatio) or 1)/ (storedJbeamData.engineInertiaAdjust or 1)
        end
        --log('I', "",  dumps(a.inertia))
    end


    if a.type == "combustionEngine"and gearRatio~=0 then --修改发动机耐久
        a.idleTorque = (a.torqueCurve[floor(a.idleRPM)]) or 10
        a.engineBrakeTorque= engineData.engineBrakeTorque* storedJbeamData.engineTorqueAdjust

        a.starterTorque= engineData.starterTorque* storedJbeamData.engineTorqueAdjust* storedJbeamData.engineInertiaAdjust/ gearRatio
        --powertrain.getDevice(_).torqueCurve = createCurve(torqueCurveScale)
        --log('I', "",  dumps(powertrain.getDevice(_).idleTorque))
        --log('I', "", "device name:".. dumps(_))
        --log('I', "", "  ".. dumps(a))
    end
end

local function scaleEngineInertia1(v)
    if (v.type=="electricMotor" or v.type=="electricMotorModded" or v.type=="combustionEngine" ) and not(v.name=="frontMotor" or v.name=="rearMotor" or v.name=="frontRightMotor" or v.name=="rearRightMotor") then
        v.inertia = v.inertia* (storedJbeamData.engineTorqueAdjust or 1)* (storedJbeamData.engineInertiaAdjust or 1)
        v.invEngInertia = v.invEngInertia/ (storedJbeamData.engineTorqueAdjust or 1)/ (storedJbeamData.engineInertiaAdjust or 1)
        v.halfInvEngInertia = v.halfInvEngInertia/ (storedJbeamData.engineTorqueAdjust or 1)/ (storedJbeamData.engineInertiaAdjust or 1)
    end
    --log('I', "", "inertia:  ".. dumps(v.inertia))
end

local function init(jbeamData)
    storedJbeamData= jbeamData

    scaleEngineTorqueInertiaDurability1()
    
    clutchMaxTorque= clutchMaxTorque* 1.3--这个参数需要遍历设备列表才能获取，所以上面函数内的循环不能删
    for _,a in pairs(powertrain.getDevices()) do    --修改离合扭矩
        if a.type== "dctGearbox"or a.type=="frictionClutch" then 
            a.lockTorque= (a.parent.torqueData.maxTorque * 1.25 + a.parent.maxRPM * a.parent.inertia * math.pi / 30) or clutchMaxTorque
            --log('I', "", "lockTorque:  ".. dumps(a.lockTorque))
        end
        if a.type== "frictionClutch" then
            a.clutchThermalsEnabledCoef= 0
        end

        log('I', "engineDurabilityUpgrade",  dumps(a.name).."   device type:  "..dumps(a.type))
        if a.gearRatios then    --提供齿比信息
            log('I', "engineDurabilityUpgrade",  dumps(a.name).."   gear ratios:  ")
            log('I', "engineDurabilityUpgrade",  dumps(a.gearRatios))
        elseif a.type=="cvtGearbox" then
            log('I', "engineDurabilityUpgrade",  dumps(a.name).."   gear ratio range:  ".. dumps(a.maxGearRatio).." ~ "..dumps(a.minGearRatio))
        elseif  a.gearRatio and a.gearRatio~=1 then
            log('I', "engineDurabilityUpgrade",  dumps(a.name).."   gear ratio:  ".. dumps(a.gearRatio))
        end
        if a.inertia then
            log('I', "engineDurabilityUpgrade",  dumps(a.name).."   inertia:  ".. dumps(a.inertia))
        end
        --if a.additionalEngineInertia then
        --    log('I', "engineDurabilityUpgrade",  dumps(a.name).." additional engine inertia:  ".. dumps(a.additionalEngineInertia))
        --end
        if a.cumulativeInertia then
            log('I', "engineDurabilityUpgrade",  dumps(a.name).."   cumulative inertia:  ".. dumps(a.cumulativeInertia))
        end
    end

end
local function reset()
    for _,v in pairs(powertrain.getDevices()) do
        if v.type == "combustionEngine" then 
            v.cylinderWallTemperatureDamageThreshold = huge
            v.headGasketDamageThreshold = huge
            v.pistonRingDamageThreshold = huge
            v.connectingRodDamageThreshold = huge
            v.maxOverTorqueDamage = huge
            v.maxOverRevDamage = huge
            v.maxTorqueRating = -1
            --powertrain.getDevice(_).jbeamData.thermalsLuaFileName = "powertrain/combustionEngineThermalsModded"
            --powertrain.getDevice(_).thermals = require("powertrain/combustionEngineThermalsModded")
            --log('I', "",  dumps(powertrain.getDevice(_).torqueCurve))
        end
        
        scaleEngineInertia1(v)

    end
end

local function updateGFX(dt)
    
    for _,v in pairs(powertrain.getDevicesByType("combustionEngine")) do
        --log('I',"",dumps(v.name))
        --if v.floodLevel>0.7 then
        --    v.floodLevel = 0.7
        --end
        v.floodLevel = 0
        --if v.type == "combustionEngine" then 
            --powertrain.getDevice(_).overTorqueDamage = 0
            --powertrain.getDevice(_).overRevDamage = 0

            
            --powertrain.getDevice(_).outputTorqueState= powertrain.getDevice(_).outputTorqueState * 2
        --end
        --local engineData= powertrain.getDevice("mainEngine")
        --if electrics.values.gearIndex then
        --    scaleEngineTorqueInertia1(engineData,powertrain.getDevice("gearbox").gearRatios[electrics.values.gearIndex])
        --end
    end

end

M.init = init
M.reset = reset
M.updateGFX = updateGFX

return M