-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
M.type = "auxilliary"
M.defaultOrder = 1100

local max, min = math.max, math.min


local lastjatoThrottleInput = 0


local thrusterCount = 0
local thrusterNodes

local smokeTick = 0

local thrusterLoopName
local thrusterLoops1
local thrusterLoops2



--                                               (id               , uiName, icon             , color   , ringValue    , onClickCallback                                                     , remove)
local function updateSimpleControlButtons()
  extensions.ui_simplePowertrainControl.setButton("jatoThrottle_" .. M.name, "jatoThrottle", "powertrain_jatoThrottle", "0072bc", 1, "electrics.values.jatoThrottleInput = 1 - (electrics.values.jatoThrottleInput or 0)")
end

local function updateGFX(dt)
  --local jatoThrottleInput = min(electrics.values.jatoThrottleInput or 0, 1)--输入为空就转换成0，输入大于1就限位到1
  local throttleInput = input.throttle or 0
  --local throttleInput = input.steering or 0
  local jatoThrottleInput = throttleInput
  local gearIndex = electrics.values.gearIndex or 0

  --[[if throttleInput == 1 and gearIndex >= 0 and (input.state.throttle.filter == FILTER_PAD or input.state.throttle.filter == FILTER_DIRECT) then
    jatoThrottleInput = 1
  end--]]





  smokeTick = smokeTick + dt * jatoThrottleInput * 100
  if smokeTick > 1 then
    for i = 1, thrusterCount, 1 do
      local thruster = thrusterNodes[i]
      obj:addParticleByNodes(thruster[1], thruster[2], 20, 81, 0.01, 1)
    end
    smokeTick = 0
  end

  if jatoThrottleInput > 0 and lastjatoThrottleInput <= 0 then
    thrusterLoops1 = thrusterLoops1 or {}
    for i = 1, thrusterCount do
      if thrusterLoops2 and thrusterLoops2[i] then
        obj:setVolume(thrusterLoops2[i], 0)
      end
      thrusterLoops1[i] = thrusterLoops1[i] or obj:createSFXSource2(thrusterLoopName, "AudioDefaultLoop3D", "jatoThrottleThrusterLoop", thrusterNodes[i][1], 0)
      obj:setVolume(thrusterLoops1[i], jatoThrottleInput)
      obj:playSFX(thrusterLoops1[i])
    end
  end

  if jatoThrottleInput <= 0 and lastjatoThrottleInput > 0 then
    for i = 1, thrusterCount do
      obj:stopSFX(thrusterLoops1 and thrusterLoops1[i] or -1)
    end
    thrusterLoops1, thrusterLoops2 = thrusterLoops2, thrusterLoops1
  end



  electrics.values.jatoThrottle = jatoThrottleInput

  lastjatoThrottleInput = jatoThrottleInput


end

local function reset()


  smokeTick = 0

  for i = 1, thrusterCount do
    obj:stopSFX(thrusterLoops1 and thrusterLoops1[i] or -1)
    obj:stopSFX(thrusterLoops2 and thrusterLoops2[i] or -1)
  end

  electrics.values.jatoThrottleInput = 0
  electrics.values.jatoThrottle = 0
end

local function init(jbeamData)


  smokeTick = 0

  electrics.values.jatoThrottleInput = 0
  electrics.values.jatoThrottle = 0

  thrusterNodes = {}
  if jbeamData.thrusterNodes_nodes then
    local nodeCount = #jbeamData.thrusterNodes_nodes
    if nodeCount % 2 == 0 then
      for i = 1, nodeCount, 2 do
        table.insert(thrusterNodes, {jbeamData.thrusterNodes_nodes[i], jbeamData.thrusterNodes_nodes[i + 1]})
      end
    else
      log("E", "jatoThrottle.init", "Even number of thruster nodes are required!")
    end
  end

  thrusterCount = #thrusterNodes
  thrusterLoopName = jbeamData.thrusterLoopName or "event:>Vehicle>Thrusters"

  extensions.inputAnalyzer.registerInputString("uuddlrlrba", inputStringCallback)
end

M.init = init--从jbeam提取数据
M.reset = reset--
M.updateGFX = updateGFX --以帧生成时间为间隔更新数据
--M.update = updatePhysics --以1/2000秒为间隔更新数据
M.inputStringCallback = inputStringCallback

--M.updateSimpleControlButtons = updateSimpleControlButtons--更新按键状态

return M
