-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M= {}
local airspeedKPH= 0
local wheelspeedKPH= 0
local min= math.min
local max= math.max
local abs= math.abs
local atan= math.atan
local sqrt= math.sqrt
local clamp= clamp


electrics.values.thrusterFlyThrottle= 0
electrics.values.thrusterFlyPitch= 0
electrics.values.thrusterFlyRoll= 0
electrics.values.thrusterFlyYaw= 0

local deltaT= 0



--local rollAV, pitchAV, yawAV = obj:getRollPitchYawAngularVelocity()
--local roll, pitch, yaw = obj:getRollPitchYaw()
local flyPIDPitchKP,flyPIDPitchKI,flyPIDPitchKD= 0.5, 0.05, 0.008
local flyPIDRollKP,flyPIDRollKI,flyPIDRollKD= 0.5, 0.05, 0.008
local flyPIDYawKP,flyPIDYawKI,flyPIDYawKD= 0.5, 0.05, 0.008
local flyPIDPitch= newPIDParallel(flyPIDPitchKP,flyPIDPitchKI,flyPIDPitchKD, -2, 2)--min output/ max output
local flyPIDRoll= newPIDParallel(flyPIDRollKP,flyPIDRollKI,flyPIDRollKD, -2, 2)
local flyPIDYaw= newPIDParallel(flyPIDYawKP,flyPIDYawKI,flyPIDYawKD, -2, 2)
local flyPIDPitchAngle= newPIDParallel(8, 0, 1, -2, 2)
local flyPIDRollAngle= newPIDParallel(8, 0, 0.8, -2, 2)
--local flyPIDYawAngle= newPIDParallel(2, 0.05, 0, -2, 2)
local bodySlipAngle= 0
local flyControlMode= 2
local useThrusterFlyThrottle


electrics.values.throttleTarget= 0
electrics.values.pitchTarget= 0
electrics.values.rollTarget= 0
electrics.values.yawTarget= 0

local rollAV, pitchAV, yawAV = obj:getRollPitchYawAngularVelocity()
local roll, pitch, yaw = obj:getRollPitchYaw()
local objGetVelocity= obj:getVelocity()
local velocityX= objGetVelocity:dot(obj:getDirectionVector())
local velocityY= objGetVelocity:dot(obj:getDirectionVectorRight())
--local velocityZ= objGetVelocity:dot(obj:getDirectionVectorUp())
local velocityXY= sqrt(velocityX^2+velocityY^2) --水平方向速度绝对值，m/s


local function updateFlyControlMode1() --angular velocity
    electrics.values.thrusterFlyYaw= flyPIDYaw:get(yawAV, 2*electrics.values.yawTarget+ bodySlipAngle*0.3, deltaT)
    electrics.values.thrusterFlyPitch= flyPIDPitch:get(pitchAV, 2*electrics.values.pitchTarget, deltaT)
    electrics.values.thrusterFlyRoll= flyPIDRoll:get(rollAV, 2*electrics.values.rollTarget, deltaT)

    --guihooks.message({txt ="_____".. flyPIDPitchAngle:get(pitch, pitch,deltaT) .."_____"      , context = {ttl = 5, color = "info"}})
end

local function updateFlyControlMode2()  --angle
    electrics.values.thrusterFlyYaw= flyPIDYaw:get(yawAV, 2*electrics.values.yawTarget+ bodySlipAngle*0.3, deltaT) --yaw: right positive
    electrics.values.thrusterFlyPitch= flyPIDPitch:get(pitchAV, flyPIDPitchAngle:get(pitch, 0.85*electrics.values.pitchTarget+ 0.5*clamp((abs(roll*electrics.values.thrusterFlyThrottle)-velocityXY/277.777777777777 ),0,1), deltaT), deltaT) --pitch: up positive
    electrics.values.thrusterFlyRoll= flyPIDRoll:get(rollAV, flyPIDRollAngle:get(-roll, 0.8*electrics.values.rollTarget,deltaT), deltaT) --roll: left positive (why not right???)
end

local updateFlyControlMode3= {
    yawTarget= 0,
    pitchTarget= 0,
    rollTarget= 0,
}
function updateFlyControlMode3.update() 
    updateFlyControlMode3.rollTarget= clamp(updateFlyControlMode3.rollTarget+ electrics.values.rollTarget* deltaT* 2, -0.85, 0.85)
    local pitchTargetLimit= 0.8- abs(updateFlyControlMode3.rollTarget)*0.45
    if abs(updateFlyControlMode3.pitchTarget)>pitchTargetLimit and electrics.values.pitchTarget~=0 then --俯仰超限值，且有俯仰输入（键盘松开时输入为零，按下即触发；模拟输入设备不受影响）
        if updateFlyControlMode3.pitchTarget>0 then
            updateFlyControlMode3.pitchTarget= pitchTargetLimit
        else
            updateFlyControlMode3.pitchTarget= -pitchTargetLimit
        end
    else
        updateFlyControlMode3.pitchTarget= clamp(updateFlyControlMode3.pitchTarget+ electrics.values.pitchTarget* deltaT*1.5 , -0.8, 0.8)
    end

    electrics.values.thrusterFlyYaw= flyPIDYaw:get(yawAV, 2*electrics.values.yawTarget+ bodySlipAngle*0.3+ updateFlyControlMode3.rollTarget*velocityX*electrics.values.thrusterFlyThrottle*0.005, deltaT) --yaw: right positive
    electrics.values.thrusterFlyPitch= flyPIDPitch:get(pitchAV, flyPIDPitchAngle:get(pitch, clamp(updateFlyControlMode3.pitchTarget, -pitchTargetLimit, pitchTargetLimit), deltaT), deltaT) --pitch: up positive
    electrics.values.thrusterFlyRoll= flyPIDRoll:get(rollAV, flyPIDRollAngle:get(-roll, updateFlyControlMode3.rollTarget,deltaT), deltaT) --roll: left positive (why not right???)
    --guihooks.message({txt = updateFlyControlMode3.pitchTarget .."___", context = {ttl = 5, color = "info"}})
end
function updateFlyControlMode3:reset()
    self.yawTarget= 0
    self.pitchTarget= 0
    self.rollTarget= 0
end

local updateFlyControlMode  --用于代入控制模式函数1、2、3等


local function init(jbeamData)
    useThrusterFlyThrottle = jbeamData.useThrusterFlyThrottle or false
    if jbeamData.flyPIDPitchKP then --pitch pid
        flyPIDPitchKP= jbeamData.flyPIDPitchKP
    end
    if jbeamData.flyPIDPitchKI then
        flyPIDPitchKI= jbeamData.flyPIDPitchKI
    end
    if jbeamData.flyPIDPitchKD then
        flyPIDPitchKD= jbeamData.flyPIDPitchKD
    end
    if jbeamData.flyPIDRollKP then --roll pid
        flyPIDRollKP= jbeamData.flyPIDRollKP
    end
    if jbeamData.flyPIDRollKI then
        flyPIDRollKI= jbeamData.flyPIDRollKI
    end
    if jbeamData.flyPIDRollKD then
        flyPIDRollKD= jbeamData.flyPIDRollKD
    end
    if jbeamData.flyPIDYawKP then --yaw pid
        flyPIDYawKP= jbeamData.flyPIDYawKP
    end
    if jbeamData.flyPIDYawKI then
        flyPIDYawKI= jbeamData.flyPIDYawKI
    end
    if jbeamData.flyPIDYawKD then
        flyPIDYawKD= jbeamData.flyPIDYawKD
    end
    if jbeamData.flyControlMode then
        flyControlMode= jbeamData.flyControlMode
    end
                        --扼杀内燃机的表演欲
    local engine= powertrain.getDevice("mainEngine")
    if not useThrusterFlyThrottle and engine then
        local rpmToAV = 0.104719755
        powertrain.getDevice("mainEngine").maxRPM = (engine.idleRPM and engine.idleRPM* 1.8)or 500
        powertrain.getDevice("mainEngine").maxAV = engine.maxRPM * rpmToAV
    end

    if flyControlMode==2 then
        updateFlyControlMode= updateFlyControlMode2
    elseif flyControlMode==3 then
        updateFlyControlMode= updateFlyControlMode3.update
        updateFlyControlMode3:reset()
    else
        updateFlyControlMode= updateFlyControlMode1
    end
end

local function reset()

    electrics.values.thrusterFlyThrottle= 0
    electrics.values.thrusterFlyPitch= 0
    electrics.values.thrusterFlyRoll= 0
    electrics.values.thrusterFlyYaw= 0
    electrics.values.pitchTarget= 0
    electrics.values.rollTarget= 0
    electrics.values.yawTarget= 0
    flyPIDPitch:reset()
    flyPIDRoll:reset()
    flyPIDYaw:reset()
    flyPIDRollAngle:reset()
    flyPIDPitchAngle:reset()
    --flyPIDYawAngle:reset()
    deltaT= 0
                        --扼杀内燃机的表演欲
    local engine= powertrain.getDevice("mainEngine")
    if not useThrusterFlyThrottle and engine then
        local rpmToAV = 0.104719755
        powertrain.getDevice("mainEngine").maxRPM = (engine.idleRPM and engine.idleRPM* 1.8)or 500
        powertrain.getDevice("mainEngine").maxAV = engine.maxRPM * rpmToAV
    end

    if flyControlMode==2 then
        updateFlyControlMode= updateFlyControlMode2
    elseif flyControlMode==3 then
        updateFlyControlMode= updateFlyControlMode3.update
        updateFlyControlMode3:reset()
    else
        updateFlyControlMode= updateFlyControlMode1
    end
    
end

local function update(dt) --2000Hz
    if deltaT<=0.05 then --20Hz
        deltaT= deltaT+dt
        return
    end

    rollAV, pitchAV, yawAV = obj:getRollPitchYawAngularVelocity()
    roll, pitch, yaw = obj:getRollPitchYaw()
    objGetVelocity= obj:getVelocity()
    velocityX= objGetVelocity:dot(obj:getDirectionVector())
    velocityY= objGetVelocity:dot(obj:getDirectionVectorRight())
    --local velocityZ= objGetVelocity:dot(obj:getDirectionVectorUp())
    velocityXY= sqrt(velocityX^2+velocityY^2) --水平方向速度绝对值，m/s

    --airspeedKPH= electrics.values.airspeed* 3.6 or 0
    --bodySlipAngle= obj:getVelocity():dot(obj:getDirectionVector())--controller.getController("CMU").virtualSensors.virtual.bodySlipAngle or "nil"
    if velocityXY*3.6>=20 then
        if velocityX>0 then
            if abs(pitch)<=0.8 then
                bodySlipAngle= clamp(velocityY*5/ velocityX , -1.5 ,  1.5 )
            else
                bodySlipAngle= 0
            end
        else 
            if velocityY>0 then
                bodySlipAngle= 1.5
            else
                bodySlipAngle= -1.5
            end
        end
        --bodySlipAngle= atan(velocityY, sqrt(velocityX^2+velocityZ^2))
    else
        bodySlipAngle= 0
    end
    
    if not useThrusterFlyThrottle then electrics.values.throttleTarget= input.throttle- input.brake
    end
    electrics.values.thrusterFlyThrottle= electrics.values.throttleTarget* ((roll^2+pitch^2)*1.8+1)

    updateFlyControlMode()
    --guihooks.message({txt = updateFlyControlMode3.pitchTarget .."___", context = {ttl = 5, color = "info"}})
    --log('W', logTag,  tostring(electrics.values.thrusterFlyThrottle))
    deltaT= 0
end


--public interface
M.update= update
M.reset= reset
M.init= init
--M.toggleThrusterDownforce= toggleThrusterDownforce
--M.toggleThrusterDynamicDownforce= toggleThrusterDynamicDownforce



return M --对外提供M集合以供调用控制函数