-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M= {}
local airspeedKPH= 0
local wheelspeedKPH= 0
local min= math.min
local max= math.max
local abs= math.abs
local atan= math.atan
local sqrt= math.sqrt
local clamp= clamp

electrics.values.thrusterDownforce= 1   -- type this in jbeam thruster section: "control":"thrusterDownforce"
electrics.values.thrusterThrottle= 0
electrics.values.thrusterBrake= 0
electrics.values.thrusterTurn= 0
electrics.values.thrusterDynamicDownforce= 0

electrics.values.thrusterFlyThrottle= nil
electrics.values.thrusterFlyPitch= 0
electrics.values.thrusterFlyRoll= 0
electrics.values.thrusterFlyYaw= 0

electrics.values.thrusterDownforceSignal= 1
electrics.values.thrusterDynamicDownforceSignal= 1
local thrusterDynamicDownforceDefaultState= 1
local thrusterDownforceDefaultState= 1


local function init(jbeamData)
    thrusterDynamicDownforceDefaultState= jbeamData.thrusterDynamicDownforceDefaultState or 1
    thrusterDownforceDefaultState= jbeamData.thrusterDownforceDefaultState or 1
    if thrusterDynamicDownforceDefaultState== 0 then
        electrics.values.thrusterDynamicDownforceSignal= 0
    else
        electrics.values.thrusterDynamicDownforceSignal= 1
    end

    if thrusterDownforceDefaultState== 0 then
        electrics.values.thrusterDownforceSignal= 0
    else
        electrics.values.thrusterDownforceSignal= 1
    end

end
local function reset()
    electrics.values.thrusterTurn= 0

    if thrusterDynamicDownforceDefaultState== 0 then
        electrics.values.thrusterDynamicDownforceSignal= 0
    else
        electrics.values.thrusterDynamicDownforceSignal= 1
    end

    if thrusterDownforceDefaultState== 0 then
        electrics.values.thrusterDownforceSignal= 0
    else
        electrics.values.thrusterDownforceSignal= 1
    end

end

local function updateGFX(dt)
    airspeedKPH= electrics.values.airspeed* 3.6 or 0
    wheelspeedKPH= electrics.values.wheelspeed* 3.6 or 0
    

    electrics.values.thrusterThrottle= input.throttle or 0
    electrics.values.thrusterBrake= input.brake or 0 

    if airspeedKPH<= 10 or wheelspeedKPH<=20 then
        electrics.values.thrusterTurn= input.steering* 0.5 or 0
    else
        electrics.values.thrusterTurn= input.steering or 0
    end

    if electrics.values.thrusterDynamicDownforceSignal== 0 then
        electrics.values.thrusterDynamicDownforce= 0
    else
        electrics.values.thrusterDynamicDownforce= max(0, min(1, (input.throttle+ input.brake)*1.7+ abs(input.steering* 3.5)+ 0) ) or 0
    end

    if electrics.values.thrusterDownforceSignal== 0 then
        electrics.values.thrusterDownforce= 0
    else
        electrics.values.thrusterDownforce= 1
    end

end

local function updateSimpleControlButtons()
    extensions.ui_simplePowertrainControl.setButton("thrusterDownforce" , "Downforce", "powertrain_jato", "0072bc", 1, "electrics.values.thrusterDownforceSignal = 1 - (electrics.values.thrusterDownforceSignal or 1)")
    extensions.ui_simplePowertrainControl.setButton("thrusterDynamicDownforce", "DynamicDownforce", "powertrain_jato", "9072bc", 0.5, "electrics.values.thrusterDynamicDownforceSignal = 1 - (electrics.values.thrusterDynamicDownforceSignal or 1)")
end


--public interface
M.updateGFX= updateGFX
M.reset= reset
M.init= init
M.updateSimpleControlButtons = updateSimpleControlButtons--更新按键状态




return M 